
(define sort
  (lambda (lst cmp)  ; cmp is a function parameter
    (letrec
        ((insert
          (lambda (x lst)  ; nested function
            (cond
              ((null? lst) (cons x '()))
              ((cmp x (car lst)) (cons x lst)) ; cmp is a non-local reference
              (else                            ; that is lexically scoped
               (cons (car lst) (insert x (cdr lst)))))))
         (nestedSort
          (lambda (lst)                ; another nested function
            (cond ((null? lst) '())
            (else (insert (car lst) (nestedSort (cdr lst))))))))
      (nestedSort lst))))

(define makeTriples
  (lambda (n1 n2)  ; (how many triples, range)
    (letrec
      ((mkrndtriple
         (lambda ()
          `(,(+ 1 (random n2)) ,(+ 1 (random n2)) ,(+ 1 (random n2)))))
       (mktriples 
         (lambda (n1 lst)
           (cond
             ((eq? n1 0) lst)
             (else
               (mktriples (- n1 1) (cons (mkrndtriple) lst)))))))
    (mktriples n1 '()))))




(define triples (makeTriples 10 10))
triples
(newline)



